/*   commondef.h
 *
 *   This file is part of FTP4ALL
 *
 *   Copyright (C) 1996,1997,1998,1999 by Christoph Schwarz
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _ftpd_commondef_h
#define _ftpd_commondef_h

#define VERSION "2.25 (07/Mar/1999)"
#define SVERSION "2.25"

struct group_s
{ char name[10];
  long gid;
} ;

struct check_s
{ char extension[8];
  char name[48];
  char param[8];
} ;

struct dshortcut_s
{ char shortname[10];
  char longname[255];
  struct dshortcut_s* next; 
  struct dshortcut_s* prev; 
} ;

struct sshortcut_s
{ char shortname[10];
  char longname[255];
} ;

struct perm_s
{ long uid;
  long gid;
  long perm;
  long dlc;
  long dlct;
  char reserved[28];
} ;

struct file_s
{ char name[MAXFILENAMELENGTH];
  long uid;
  long gid;
  long dlc;
  long perm;
} ;

#define CL_NORMAL    0
#define CL_SHUTDOWN -1
#define CL_TIMEOUT  -2
#define CL_SOCKERR  -3
#define CL_KICK     -4
#define CL_PIPEERR  -5
#define CL_ERROR    -6
#define CL_FORCE    -7

#define P_CHDIR     0x01
#define P_LIST      0x02
#define P_MKDIR     0x04
#define P_CHMOD     0x08
#define P_READ      0x10
#define P_WRITE     0x20
#define P_OVERWRITE 0x40
#define P_NOLIMIT   0x80
#define P_ALL       0x7F

#define FP_READ     0x04
#define FP_WRITE    0x02
#define FP_CHMOD    0x08
#define FP_ALL      0x0E

#define LG_ALL      0x07FF
#define LG_CD       0x0001
#define LG_DEL      0x0002
#define LG_GET      0x0004
#define LG_LOGIN    0x0008
#define LG_LOGOUT   0x0010
#define LG_LS       0x0020
#define LG_MD       0x0040
#define LG_PUT      0x0080
#define LG_RD       0x0100
#define LG_REN      0x0200
#define LG_CHMOD    0x0400

void* alloc(void*,long);

#endif

/* EOF */
