/*   defines.h
 *
 *   This file is part of FTP4ALL
 *
 *   Copyright (C) 1996,1997,1998,1999 by Christoph Schwarz
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _ftps_defines_h
#define _ftps_defines_h

#include "commondef.h"

struct user_s
{ char name[10];
  long uid;
} ;

struct user_f_s
{ char name[10];
  long uid;
  long gid;
  long kb_downloaded;
  long kb_uploaded;
  long last_login;
  int  limit;
  long credit;
  long gids[8];
  long class;
} ;

struct top_s
{ char  u_name[10];
  long  u_amount;
  char  u_info[16];
  char  d_name[10];
  long  d_amount;
  char  d_info[16];
  char  e_name[10];
  float e_amount;
  char  e_info[16];
  char  l_name[10];
  float l_amount;
  char  l_info[16];
} ;

#define S_FILE      1
#define S_RECORD    2
#define T_ASCII     1
#define T_IMAGE     2

#define sig_size    4

int             file_permission_ok(char*,char*,long);
struct file_s*  find_name(struct file_s*,char*,int,int*);
long            get_gid(char*);
struct group_s* get_group_by_gid(long);
char*           get_groupname(long);
long            get_uid(char*);
struct user_s*  get_user_by_uid(long);
char*           get_username(long);
int             in_group(long);
int             permission_ok(char*,int);
void            split_dir(char*,char**,char**,int);
int             superuser(void);
int             groupop(void);
int             useredit(void);
int             coloruser(void);
int             invisible(void);

#endif

/* EOF */
