/*   definesd.h
 *
 *   This file is part of FTP4ALL
 *
 *   Copyright (C) 1996,1997,1998,1999 by Christoph Schwarz
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _ftpd_definesd_h
#define _ftpd_definesd_h

#include "commondef.h"

struct user_s
{ char   name[10];
  long   uid;
  long   gid;
  char   password[40];
  long   kb_downloaded;
  long   kb_uploaded;
  time_t last_login;
  char   idents[10][20]; /* 12bytes for ident; 8byte for iprange */
  int    limit;
  char   info[16];
  long   credit;
  long   gids[8];
  long   class;
  long   kb_down_tmp;
  long   kb_up_tmp;
} ;

struct child_s
{ time_t         act_time;
  char           activity[80];
  int            idle;
  long           ip;
  char		 ident[12];
  long           kb_down;
  long           kb_up;
  pid_t          pid;
  FILE*          rdp;
  int            sock;
  time_t         time;
  struct user_s* user;
  FILE*          wrp;
} ;

struct msg_s
{ char* filename;
  long  filedate;
  char* msg;
  int   len;
  int   size;
  char* default_msg;
} ;

#define UC_MASK     0x03
#define UC_ROOT     0x00
#define UC_NORMAL   0x01
#define UC_ANON     0x02
#define UC_TEMPLATE 0x03

#define USC_MASK     0x300
#define USC_GROUPOP  0x100
#define USC_USEREDIT 0x200

#define UE_MASK      0xC80
#define UE_COLOR     0x080
#define UE_INVISIBLE 0x400
#define UE_NOPASSCH  0x800


#define sig_size 16

#define R_ALL          0xFFFFFFFF
#define R_ENABLE       0x00000001
#define R_DISABLE      0x00000002

#define R_GROUP_ALL    0x0000003C
#define R_GROUP_ADD    0x00000004
#define R_GROUP_CHANGE 0x00000008
#define R_GROUP_REMOVE 0x00000010
#define R_GROUP_LIST   0x00000020

#define R_GROUPS       0x00000040
#define R_KICK         0x00000080
#define R_MAX          0x00000100

#define R_USER_ALL     0x0003FE00
#define R_USER_ADD     0x00000200
#define R_USER_PASSWD  0x00000400
#define R_USER_CHANGE       0x00007800
#define R_USER_CHANGE_IP    0x00000800
#define R_USER_CHANGE_STATS 0x00001000
#define R_USER_CHANGE_RATIO 0x00002000
#define R_USER_CHANGE_OTHER 0x00004000
#define R_USER_LIST    0x00008000
#define R_USER_REMOVE  0x00010000
#define R_USER_RESET   0x00020000

#endif

/* EOF */
