/*   externs.h
 *
 *   This file is part of FTP4ALL
 *
 *   Copyright (C) 1996,1997,1998,1999 by Christoph Schwarz
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _ftps_externs_h
#define _ftps_externs_h

#include "defines.h"

extern struct sockaddr_in  addr;
extern char                anonymous;
extern long                bytes_downloaded;
extern long                bytes_uploaded;
extern char*               cdpath;
extern int                 cdpath_size;
extern char*               cdup_msg;
extern char*               chdir_msg;
extern struct check_s*     check;
extern int                 check_count;
extern int                 checktimeout;
extern int                 chmodallowed;
extern int                 close_reason;
extern char                close_server;
extern char                cwd[256];
extern struct check_s*     dcheck;
extern int                 dcheck_count;
extern char*               dele_msg;
extern char*               download_msg;
extern struct sshortcut_s* dshortcut;
extern int                 dshortcut_count;
extern int                 dshortcut_size;
extern char*               dupechk;
extern int                 dupechk_size;
extern char*               dupe_path;
extern int                 fconv_mode;
extern char*               ff_path;
extern struct group_s*     group;
extern int                 group_count;
extern long                ipaddr;
extern int                 kb_downloaded;
extern int                 kb_uploaded;
extern long                last_speed;
extern char*               list_msg;
extern long                logc;
extern char                logged_in;
extern int                 login_kick;
extern int                 login_retries;
extern int                 max_anon;
extern int                 max_users;
extern long                mbytes_downloaded;
extern long                mbytes_uploaded;
extern char*               message;
extern char*               mkdir_msg;
extern int                 msg_len;
extern int                 msg_size;
extern int                 num_anon;
extern int                 num_users;
extern long                other_ip_s;
extern int                 pasvsock;
extern char*               permission_file;
extern char*               pre_download;
extern char*               pre_upload;
extern char*               readme_file;
extern long                rest_offset;
extern int                 retries;
extern char*               script_path;
extern int                 scriptabort;
extern char*               shortcut;
extern int                 sig_array[];
extern int                 sig_read;
extern int                 sig_write;
extern int                 sock;
extern FILE*               sockf;
extern FILE*               sockfr;
extern char                structure;
extern int                 timeout;
extern struct top_s        top[10];
extern char                touch;
extern char                type;
extern long                umask_value;
extern char*               upload_msg;
extern struct user_s*      user;
extern int                 user_count;
extern struct user_f_s     usr;

#endif

/* EOF */
