/*   externsd.h
 *
 *   This file is part of FTP4ALL
 *
 *   Copyright (C) 1996,1997,1998,1999 by Christoph Schwarz
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _ftpd_externsd_h
#define _ftpd_externsd_h

#include "definesd.h"

extern char default_base_dir[];
extern char default_cdup_msg[];
extern char default_chdir_msg[];
extern char default_dele_msg[];
extern char default_download_msg[];
extern char default_errlog_file[];
extern char default_goodbye_msg[];
extern char default_list_msg[];
extern char default_log_file[];
extern char default_mkdir_msg[];
extern char default_permission_file[];
extern char default_server_program[];
extern char default_startup_msg[];
extern char default_toomanyanon_msg[];
extern char default_toomanyuser_msg[];
extern char default_upload_msg[];
extern char default_welcome_msg[];
extern char default_whoonline_msg_top[];
extern char default_whoonline_msg_body[];
extern char default_whoonline_msg_tail[];

extern char*               alternative_srv;
extern char*               base_dir;
extern char*               bouncer;
extern char*               cdpath;
extern int                 cdpath_len;
extern int                 cdpath_size;
extern struct msg_s        cdup_msg;
extern struct msg_s        chdir_msg;
extern struct check_s*     check;
extern int                 check_count;
extern int                 checktimeout;
extern int                 check_size;
extern struct child_s*     child;
extern int                 child_size;
extern int                 children;
extern char                chmodallowed;
extern struct check_s*     dcheck;
extern int                 dcheck_count;
extern int                 dcheck_size;
extern struct msg_s        dele_msg;
extern char*               destroy_login;
extern char*               destroy_password;
extern struct msg_s        download_msg;
extern struct dshortcut_s* dshortcut;
extern int                 dshortcut_count;
extern int                 dshortcut_size;
extern struct msg_s        dupechk;
extern char*               dupe_path;
extern char*               errlog_file;
extern FILE*               errlogf;
extern int                 fconv_value;
extern char*               ff_path;
extern struct msg_s        goodbye_msg;
extern struct group_s*     group;
extern int                 group_count;
extern char*               group_file;
extern int                 group_size;
extern int                 groupop_limit;
extern long                groupop_rights;
extern char                ident_mode;
extern struct msg_s        list_msg;
extern long                logc;
extern char*               log_file;
extern pid_t               log_pid;
extern char*               log_program;
extern FILE*               log_program_f;
extern FILE*               logf;
extern int                 login_kick;
extern int                 login_kick_signo;
extern int                 login_retries;
extern int                 max_anon;
extern int                 max_anon_domain;
extern int                 max_anon_ip;
extern int                 max_users;
extern struct msg_s        mkdir_msg;
extern int                 num_anon;
extern int                 num_users;
extern char*               other_ip;
extern char*               permission_file;
extern char*               pid_file;
extern int                 port;
extern char*               pre_download;
extern char*               pre_upload;
extern char                private_mode;
extern char*               program_name;
extern char*               readme_file;
extern char                resolver;
extern char*               script_path;
extern char                server_closed;
extern char*               server_dir;
extern char*               server_program;
extern struct msg_s        shortcut;
extern int                 sig_array[];
extern int                 sig_read;
extern int                 sig_write;
extern int                 ss2;
extern struct msg_s        startup_msg;
extern char*               stat_file;
extern int                 timeout_anon;
extern int                 timeout_user;
extern struct msg_s        toomanyanon_msg;
extern struct msg_s        toomanyuser_msg;
extern struct user_s*      top_u[10];
extern struct user_s*      top_d[10];
extern struct user_s*      top_e[10];
extern struct user_s*      top_l[10];
extern char                top_ok;
extern char                touch;
extern long                umask_anon;
extern long                umask_root;
extern long                umask_user;
extern int                 umask_value;
extern struct msg_s        upload_msg;
extern struct user_s*      user;
extern int                 user_count;
extern char*               user_file;
extern int                 user_size;
extern int                 useredit_limit;
extern long                useredit_rights;
extern char                wait_port;
extern struct msg_s        welcome_msg;
extern struct msg_s        welcome_msg_anon;
extern struct msg_s        whoonline_msg_top;
extern struct msg_s        whoonline_msg_body;
extern struct msg_s        whoonline_msg_tail;

#ifdef DES_ENCRYPTION
  extern char              user_encrypted;
  extern C_Block           user_key;
#endif

#ifdef DEBUG
  extern FILE* debugf;
#endif

#endif

/* EOF */
