/*   globals.h
 *
 *   This file is part of FTP4ALL
 *
 *   Copyright (C) 1996,1997,1998,1999 by Christoph Schwarz
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _ftps_globals_h
#define _ftps_globals_h

#include "defines.h"

struct sockaddr_in addr;
char                anonymous           = 0;
int                 bsize               = 4096;
long                bytes_downloaded    = 0;
long                bytes_uploaded      = 0;
char*               cdpath              = NULL;
int                 cdpath_size         = 0;
char*               cdup_msg            = NULL;
char*               chdir_msg           = NULL;
struct check_s*     check               = NULL;
int                 check_count         = 0;
int                 checktimeout        = 0;
int                 chmodallowed        = 1;
int                 close_reason        = CL_ERROR;
char                close_server        = 0;
char                cwd[256]            = "/";
struct check_s*     dcheck              = NULL;
int                 dcheck_count        = 0;
char*               dele_msg            = NULL;
char*               download_msg        = NULL;
struct sshortcut_s* dshortcut           = NULL;
int                 dshortcut_count     = 0;
int                 dshortcut_size      = 0;
char*               dupechk             = NULL;
int                 dupechk_size        = 0;
char*               dupe_path           = NULL;
int                 fconv_mode          = 0;
char*               ff_path             = NULL;
struct group_s*     group               = NULL;
int                 group_count         = 0;
int                 group_size          = 0;
long                ipaddr              = 0;
int                 kb_downloaded       = 0;
int                 kb_uploaded         = 0;
long                last_speed          = 0;
char*               list_msg            = NULL;
long                logc                = 0;
char                logged_in           = 0;
int                 login_kick          = 0;
int                 login_retries       = 0;
int                 max_anon            = 0;
int                 max_users           = 0;
long                mbytes_downloaded   = 0;
long                mbytes_uploaded     = 0;
char*               message             = NULL;
char*               mkdir_msg           = NULL;
int                 msg_len             = 0;
int                 msg_size            = 0;
int                 num_anon            = 0;
int                 num_users           = 0;
long                other_ip_s          = 0;
int                 pasvsock            = -1;
char*               permission_file     = NULL;
char*               pre_download        = NULL;
char*               pre_upload          = NULL;
char*               readme_file         = NULL;
long                rest_offset         = 0;
int                 retries             = 0;
char*               script_path         = NULL;
int                 scriptabort         = 0;
char*               shortcut            = NULL;
int                 sig_array[sig_size];
int                 sig_read            = 0;
int                 sig_write           = 0;
int                 sock;
FILE*               sockf;
FILE*               sockfr;
char                structure           = S_FILE;
int                 timeout             = 60;
struct top_s        top[10]             = { 0,0,0,0,0,0,0,0,0,0,0,0 };
char                touch               = 0;
char                type                = T_ASCII;
long                umask_value;
char*               upload_msg          = NULL;
struct user_s*      user                = NULL;
int                 user_count          = 0;
int                 user_size           = 0;
struct user_f_s     usr                 = { 0,0,0,0,0,0,0,0,0,0 };

#endif

/* EOF */
