/*   globalsd.h
 *
 *   This file is part of FTP4ALL
 *
 *   Copyright (C) 1996,1997,1998,1999 by Christoph Schwarz
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _ftpd_globalsd_h
#define _ftpd_globalsd_h

#include "definesd.h"

char default_base_dir[]        = "/home/ftp";
char default_cdup_msg[]        = "CDUP command successful.\n";
char default_chdir_msg[]       = "CWD command successful.\n";
char default_dele_msg[]        = "DELE command successful.\n";
char default_download_msg[]    = "Transfer completed.\n";
char default_errlog_file[]     = "ftpd.err";
char default_goodbye_msg[]     = "Goodbye.\n";
char default_list_msg[]        = "Directory listing completed.\n";
char default_log_file[]        = "ftpd.log";
char default_mkdir_msg[]       = "MKDIR command successful.\n";
char default_permission_file[] = ".permissions";
char default_server_program[]  = "ftps";
char default_startup_msg[]     = "FTP4ALL Server "VERSION" ready.\n";
char default_toomanyanon_msg[] = "Too many anonymous users are logged in at the moment. Try again later.\n";
char default_toomanyuser_msg[] = "Too many users are logged in at the moment. Try again later.\n";
char default_upload_msg[]      = "Transfer completed.\n";
char default_welcome_msg[]     = "User %S logged in.\n";
char default_whoonline_msg_top[] = " !CNR HANDLE    GROUP     ON-TM AC-TM MUP!H/!CMDN ACTIVITY !H/ (!CLAST ACTIVITY!H)!0";
char default_whoonline_msg_body[] = " !G%W[%02li]C!H%W[]o!D%W[%-9s]N !G%W[%-9s]G %W[!H%H!C:!H%M!C]T %W[!H%M!C:!H%S!C]t!0 !D%W[%3li]M!H/!D%W[%3li]m %W[!H(!0]l!D%W[%s]A%W[!H)!0]l!0";
char default_whoonline_msg_tail[] = " !HFTP!B4!HALL v"SVERSION"          !CHH!c:!CMM MM!c:!CSS !HON-TM=ONLINE TIME / AC-TM=ACTIVITY TIME!0";

char*           alternative_srv  = NULL;
char*           base_dir         = NULL;
char*           bouncer          = NULL;
char*           cdpath           = NULL;
int             cdpath_len       = 0;
int             cdpath_size      = 0;
struct msg_s    cdup_msg         = { NULL,0,NULL,0,0,default_cdup_msg };
struct msg_s    chdir_msg        = { NULL,0,NULL,0,0,default_chdir_msg };
struct check_s* check            = NULL;
int             check_count      = 0;
int             checktimeout     = 0;
int             check_size       = 0;
struct child_s* child            = NULL;
int             child_size       = 0;
int             children         = 0;
char            chmodallowed     = 1;
struct check_s* dcheck           = NULL;
int             dcheck_count     = 0;
int             dcheck_size      = 0;
struct msg_s    dele_msg         = { NULL,0,NULL,0,0,default_dele_msg };
char*           destroy_login    = NULL;
char*           destroy_password = NULL;
struct msg_s    download_msg     = { NULL,0,NULL,0,0,default_download_msg };
struct dshortcut_s* dshortcut       = NULL;
int                 dshortcut_count = 0;
int                 dshortcut_size  = 0;
struct msg_s    dupechk          = { NULL,0,NULL,0,0,NULL };
char*           dupe_path        = NULL;
char*           errlog_file      = NULL;
FILE*           errlogf          = NULL;
int             fconv_value      = 0;
fd_set          fdset;
char*           ff_path          = NULL;
struct msg_s    goodbye_msg      = { NULL,0,NULL,0,0,default_goodbye_msg };
struct group_s* group            = NULL;
int             group_count      = 0;
char*           group_file       = NULL;
int             group_size       = 0;
int             groupop_limit    = 33;
long            groupop_rights   = 0;  
char            ident_mode       = 0;
struct msg_s    list_msg         = { NULL,0,NULL,0,0,default_list_msg };
long            logc             = 0;
char*           log_file         = NULL;
pid_t           log_pid          = 0;
char*           log_program      = NULL;
FILE*           log_program_f    = NULL;
FILE*           logf             = NULL;
int             login_kick       = 0;
int             login_kick_signo = SIGKILL;
int             login_retries    = 10;
int             max_anon         = 10;
int             max_anon_domain  = 10;
int             max_anon_ip      = 10;
int             max_users        = 10;
struct msg_s    mkdir_msg        = { NULL,0,NULL,0,0,default_mkdir_msg };
int             num_anon         = 0;
int             num_users        = 0;
char*           other_ip         = NULL;
char*           permission_file  = NULL;
char*           pid_file         = NULL;
int             port             = 21;
char*           pre_download     = NULL;
char*           pre_upload       = NULL;
char            private_mode     = 0;
char*           program_name     = NULL;
char*           readme_file      = NULL;
char            resolver         = 1;
char*           script_path      = NULL;
char            server_closed    = 0;
char*           server_dir       = NULL;
char*           server_program   = NULL;
struct msg_s    shortcut         = { NULL,0,NULL,0,0,NULL };
int             sig_array[sig_size];
int             sig_read         = 0;
int             sig_write        = 0;
int             ss2              = -1;
struct msg_s    startup_msg      = { NULL,0,NULL,0,0,default_startup_msg };
char*           stat_file        = NULL;
int             timeout_anon     = 60;
int             timeout_user     = 300;
struct msg_s    toomanyanon_msg  = { NULL,0,NULL,0,0,default_toomanyanon_msg };
struct msg_s    toomanyuser_msg  = { NULL,0,NULL,0,0,default_toomanyuser_msg };
struct user_s*  top_u[10]        = { NULL };
struct user_s*  top_d[10]        = { NULL };
struct user_s*  top_e[10]        = { NULL };
struct user_s*  top_l[10]        = { NULL };
char            top_ok           = 0;
char            touch            = 0;
long            umask_anon       = 0x230000;
long            umask_root       = 0x7F1300;
long            umask_user       = 0x7F1300;
int             umask_value      = 077;
struct msg_s    upload_msg       = { NULL,0,NULL,0,0,default_upload_msg };
struct user_s*  user             = NULL;
int             user_count       = 0;
char*           user_file        = NULL;
int             user_size        = 0;
int             useredit_limit   = 33;
long            useredit_rights  = 0;
char            wait_port        = 0;
struct msg_s    welcome_msg      = { NULL,0,NULL,0,0,default_welcome_msg };
struct msg_s    welcome_msg_anon = { NULL,0,NULL,0,0,default_welcome_msg };
struct msg_s    whoonline_msg_top  = { NULL,0,NULL,0,0,default_whoonline_msg_top };
struct msg_s    whoonline_msg_body = { NULL,0,NULL,0,0,default_whoonline_msg_body };
struct msg_s    whoonline_msg_tail = { NULL,0,NULL,0,0,default_whoonline_msg_tail };

#ifdef DES_ENCRYPTION
  char          user_encrypted   = 0;
  C_Block       user_key;
#endif

#ifdef DEBUG
  FILE* debugf = NULL;
#endif

#endif

/* EOF */
